# Contributing

Types of contributions we welcome:

* Reporting issues with existing features
* Bug fixes
* Performance improvements
* Documentation and/or clearer interfaces

## Proposing Features

The main use case for this project is around batching queries
for GraphQL requests, but is open to changes that make it more
generic. This includes supporting concurrent or parallel executors.

When in doubt about whether we will be interested in including a
new feature in this project, please open an issue to propose the
feature so we can confirm the feature should be in scope for the
project before it is implemented.

## How To Contribute

1. Fork the [repository in github](https://github.com/Shopify/graphql-batch)
2. Create your feature branch (`git checkout -b fix-feature`)
3. Commit your changes (`git commit -am 'fix: Summarize change'`)
3. Make sure all tests pass (`bundle exec rake`)
4. Push to the branch (`git push origin fix-feature`)
5. [Create new pull request](https://github.com/Shopify/graphql-batch/pulls)
